#include "lsqrms.h"
#include <ctype.h>

#ifndef _toupper
# define _toupper(x) (toupper((x)))
#endif
#ifndef _tolower
# define _tolower(x) (tolower((x)))
#endif

#define tohigh(x) ((x) | ~0177)

typedef double rotate_t[3][3];
typedef double xlate_t[3];
typedef struct Coord { double x, y, z; } CoordType;

double bestfit(rotate_t , xlate_t , CoordType *, CoordType *, const int );
double rotrans(double **, int, rotate_t, xlate_t);
int check_eq(int *, int *, int *, int *, int);
double distrms(CoordType *a, CoordType *b, int npts);

char convert321(char *, int, int);
double blosum62(char, char, int, int);
double nussinov(char, char, int, int);
double gonnet_p(char, char, int, int);
double glyproaln(char, char, int, int);
double pam120_p(char, char, int, int);
double check_carbonyl(char, char);

double findCM(double **, int, double *);
/* Below could actually be unified with rotrans - Allen */
double TRmoveXYZstruc(double *,double **,double **, int);
int FindMaxXYZDistIdxLast(double **, int);
int FindMaxXYDistIdxLast(double **, int);
double AlignZ(double, double, double, double *, double *);
double FormRotMatrX(double **, double);
double FormRotMatrY(double **, double);
double FormRotMatrZ(double **, double);
